//+------------------------------------------------------------------+
//|                                             ind_PolinomMA_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer CrazyExperimentCoLtd:-)  -Infinity to +Infinity"
#property link      "for-good-letters@yandex.ru"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters

//  K0*X^0+K1*X^1+K2*X^2+K3*X^3...

extern   int      FilterLength=34;
extern   string   K="1/5/6/1/-20";
extern   double   ArgumentMin=-1;
extern   double   ArgumentMax=1;
extern   bool     ControlMode=false; 

//---- buffers
double ExtMapBuffer1[];
double KAr[];
double NAr[];

double FK[];
double Del;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){

   string tmpStr[];
   fSplitStrToStr(K,tmpStr,"/");
   ArrayResize(KAr,ArraySize(tmpStr));
      for(int i=0;i<ArraySize(tmpStr);i++){
         KAr[i]=StrToDouble(tmpStr[i]);
      }

      
   ArrayResize(FK,FilterLength);

      for(i=0;i<ArraySize(FK);i++){
         FK[ArraySize(FK)-i-1]=0;
         double X=ArgumentMin+(ArgumentMax-ArgumentMin)*i/(ArraySize(FK));
            for(int j=0;j<ArraySize(KAr);j++){
               FK[ArraySize(FK)-i-1]+=KAr[j]*MathPow(X,j);
            }
         Del+=FK[ArraySize(FK)-i-1];  
      }
      for(i=0;i<ArraySize(FK);i++){
         FK[i]-=FK[ArraySize(FK)-1];
      } 
   double tmp=FK[0];
      for(i=0;i<ArraySize(FK);i++){
         FK[i]/=tmp;
      }        
   Del=0; 
      for(i=0;i<ArraySize(FK);i++){
         Del+=FK[i];
      }     
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("PolinommaHL");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){


         if(ControlMode){
               for(int j=0;j<ArraySize(FK);j++){
                  ExtMapBuffer1[j]=Close[1]+Point*100*FK[j];
               }
               fObjHLine("PolinommaHL",Close[1],Red,1,0,0,false);
               
            return(0);
         }

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               ExtMapBuffer1[i]=0;
                  for(j=0;j<ArraySize(FK);j++){
                     ExtMapBuffer1[i]+=FK[j]*Close[i+j];
                  }
               ExtMapBuffer1[i]/=Del;
            }
            
   return(0);
}
//+------------------------------------------------------------------+

void fObjHLine(
   string aObjectName,  // 1 
   double aPrice_1,     // 2 
   color aColor=Red,    // 3 
   int aWidth=1,        // 4 
   int aWindowNumber=0, // 5 
   int aStyle=0,        // 6 0-STYLE_SOLID, 1-STYLE_DASH, 2-STYLE_DOT, 3-STYLE_DASHDOT, 4-STYLE_DASHDOTDOT
   bool aBack=false     // 7 
   ){
   
   // fHLine("",Close[1]);
   // fHLine("",Close[1],Red,1,0,STYLE_SOLID,false);
   
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_HLINE,aWindowNumber,0,aPrice_1);
      }      
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSet(aObjectName,OBJPROP_COLOR,aColor);
   ObjectSet(aObjectName,OBJPROP_WIDTH,aWidth);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);   
   ObjectSet(aObjectName,OBJPROP_STYLE,aStyle);            
}


int fSplitStrToStr(string aString,string & aArray[],string aDelimiter){
string tmp_str="";
string tmp_char="";
ArrayResize(aArray,0);
   for(int i=0;i<StringLen(aString);i++){
      tmp_char=StringSubstr(aString,i,1);
         if(tmp_char==aDelimiter){
               if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
                  ArrayResize(aArray,ArraySize(aArray)+1);
                  aArray[ArraySize(aArray)-1]=tmp_str;
               }
            tmp_str="";
         }
         else{
            if(tmp_char!=" ")tmp_str=tmp_str+tmp_char;
         }
   }
   if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
      ArrayResize(aArray,ArraySize(aArray)+1);
      aArray[ArraySize(aArray)-1]=tmp_str;
   } 
return(ArraySize(aArray));
}

